# Tutorial APAP
## Authors
> **Muhammad Raihan Adliputra** - *2006485680* - *A*

## Tutorial 8
1. Apa itu Dockerfile dan docker-compose.yaml? Apa fungsinya?<br />
* **Dockerfile** berfungsi untuk mem-*build* *image*, sementara **docker-compose.yaml** berfungsi untuk menjalankan *image* tersebut.
* **Dockerfile** menggunakan command `docker-build`, sementara **docker-compose.yaml** menggunakan command `docker-compose up`.
* Sebuah file **docker-compose.yml** bisa mereferensikan kepada sebuah **Dockerfile**, tapi sebuah **Dockerfile** tidak bisa melakukan sebaliknya.

2. Screenshot hasil perubahan anda. Setelah anda menyelesaikan tutorial ini, menurut anda, mengapa kita perlu mengganti port?<br />
![Image](/belajarbelajar/images/Tutor8-2.png "SS Changes")<br />
Kita harus mengganti port agar port yang kita gunakan tidak clash dengan kepentingan pada port lainnya.

3. Mengapa terdapat versi dev dan prod? File apa yang menentukan konfigurasi mana yang dipakai? Apa yang harus dilakukan untuk menjalankan versi prod? (hint: baca file pada langkah 3 dengan teliti)<br />
* Versi **dev** digunakan untuk melakukan *testing*, *staging*, *development*, dan *production environments*.
* Versi **prod** digunakan untuk *production* saja.

4. Apa saja yang terjadi di langkah ini?<br />
* Sistem akan mencoba meng-load semua file config dari custom docker
* Menjalin koneksi dengan konfigurasi Docker daemon
* Mencoba untuk membuat network dari proyek kita
* Mencoba untuk membuat volume dari proyek kita
* Mencari apakah sudah ada sebuah container yang sudah dibuat untuk proyek kita
* Mencari apakah sudah ada sebuah image yang sudah dibuat untuk proyek kita
* Membuat container proyek
* Menjalankan container proyek
* Mengecek secara berkala dari container proyek

5. Sertakan screenshot container yang sedang berjalan (versi gui atau cli, pilih salah satu). Apa itu docker container, images, dan volume?<br />
![Image](/belajarbelajar/images/Tutor8-5.png "Container")<br />
* **docker image** merupakan kumpulan file yang menunjang sebuah aplikasi.
* **docker container** merupakan wadah untuk mengemas dan menjalankan aplikasi, mencakup kode, *runtime*, *system tools*, dan pengaturan. Container hanya bisa mengakses *resource* yang telah ditentukan dalam Docker image.
* **docker volume** akan digunakan untuk menyimpan data agar ketika container di hapus, data masih aman tidak ikut terhapus bersama dengan container. **Docker volume** juga bisa digunakan untuk *sharing* direktori atau file kepada container yang diinginkan.

6. Apa perbedaan docker-compose down dan stop?<br />
* `docker-compose down` merupakan sebuah command yang akan menghentikan proses di dalam container dan akan me-*remove* container yang dihentikan, serta network-network yang sebelumnya pernah dibuat.
* `docker-compose stop` merupakan sebuah command yang akan menghentikan proses di dalam container tapi tidak akan me-*remove* mereka.

7. Sertakan screenshot mengakses laman kirti milik anda melalui browser (seperti screenshot di atas)<br />
![Image](/belajarbelajar/images/Tutor8-7.png "Kirti Access")

8. Ceritakan pengalaman anda melakukan deployment ke Kirti. Kendala apa yang anda alami?
Tidak ada permasalahan major.

9. Buka container docker Anda, lalu screenshot. Apa perbedaan tampilan container sekarang dengan tampilan container pada langkah tutorial docker di awal tadi?<br />
![Image](/belajarbelajar/images/Tutor8-9.png "Docker Containers")

10. Sertakan screenshot tampilan web ketika pertama kali menjalankan localhost:9090 dan tampilan web ketika halaman di-refresh.<br />
![Image](/belajarbelajar/images/Tutor8-10-1.png "First")<br />
![Image](/belajarbelajar/images/Tutor8-10-2.png "Second")

11. Kendala apa yang anda hadapi ketika melakukan tutorial bagian nginx?<br />
* Saya sempat bingung cara menjalankan nginx setelah saya mendownload zip foldernya.
* Saya bingung cara operasi nginx secara keseluruhan, sehingga saya harus bertanya terus kepada kakak asdos.

## Tutorial 7
1. Jelaskan secara singkat perbedaan Otentikasi dan Otorisasi! Di bagian mana (dalam kode yang telah anda buat) konsep tersebut diimplementasi?<br />
* **Otentifikasi** adalah proses verifikasi agar user bisa masuk ke dalam sistem, atau dalam kata lain **otentifikasi** akan mengecek siapakah user yang ingin masuk dan mengecek pula *role* dari si user. **Otentifikasi** dilakukan pada potongan kode:
```
@Autowired
public void configAuthentication(AuthenticationManagerBuilder auth) throws Exception {
    auth.userDetailsService(userDetailsService).passwordEncoder(encoder());
}
```
* **Otorisasi** adalah kegiatan memberikan akses kepada seorang user sesuai dengan rolenya masing-masing. **Otorisasi** dilakukan pada potongan kode:
```
.antMatchers("/user/viewall").hasAuthority("Admin")
```
```
<div sec:authorize="hasAuthority('Admin')
```

2. Apa itu BCryptPasswordEncoder? Jelaskan secara singkat cara kerja dan tujuannya.<br />
**BCryptEncoder** merupakan encoder kata sandi satu arah. **BCryptEncoder** bekerja secara otomatis men-generate lalu menggunakan random salt untuk menentukan hashingnya, sehingga nanti akan menghasilkan hasing yang berbeda-beda.

3. Apakah penyimpanan password sebaiknya menggunakan encryption atau hashing? Mengapa demikian?<br />
Penyimpanan password sebaiknya menggunakan **enkripsi**. Hal tersebut dikarenakan enkripsi akan berguna dalam penyandian sebuah data dan kerahasiaan dari data tersebut pun akan terjaga.

4. Jelaskan secara singkat apa itu UUID beserta penggunaannya!<br />
**Universally Unique Identifier** atau **UUID** merupakan kode yang bersifat unik/tidak ada objek lain yang akan sama dengan UUID tersebut. **UUID** terdiri dari 32 karakter dan biasanya digunakan sebagai *identifier* atau *id* dari sebuah objek.

5. Apa kegunaan class UserDetailsServiceImpl.java? Mengapa harus ada class tersebut?<br />
**Class UserDetailsServiceImpl.java** merupakan sebuah class bertipe interface yang digunakan untuk men-setting otorisasi dan otentikasi. Jika class tersebut tidak dibuat maka info terkait otentikasi dan otorisasi tidak bisa diberikan.

## Tutorial 6
### Pertanyaan
1. Perhatikan apa yang terjadi pada file index.html pada branch feat/tutorial-6-advancedgit-1. Apa yang terjadi setelah git cherry-pick dilakukan? Apakah kita bisa melakukan cherrypick tanpa harus melakukan commit?<br />
Yang terjadi setelah **git cherry-pick** dilakukan adalah menghilangkan file index.html pada branch `feat/tutorial-6-advancedgit-1`. Hal tersebut bisa terjadi karena *commit* belum dilakukan setelah menjalankan command **git cherry-pick**. Oleh karena itu, kita perlu melakukan *commit* terlebih dahulu setelah menjalankan command **git cherry-pick**.

2. Oops! terjadi conflict nih. Yap, conflict ini terjadi karena … <br />
Isi yang ada pada file *index.html* berbeda pada branch `feat/tutorial-6-advancedgit-1` dan branch `tut6-for-merge`.

3. Apa yang terjadi pada log history setelah melakukan rebase (branch rebase-1 dan rebase-2)? Sertakan screenshot log history anda pada kedua branch tersebut!<br />
Yang terjadi pada log history setelah melakukan rebase antara branch `rebase-1` dan branch `rebase-2` adalah log dari branch `rebase-1` hanya memiliki pesan commit **"add a.txt"**. Sedangkan pada branch `rebase-2` akan memiliki pesan commit dari log branch `rebase-1` dan pesan commit dari log miliknya sendiri. Berikut adalah hasil screenshot dari isi log pada branch `rebase-2` saya:<br />
![](screenshoot/log.jpg)

4. Jelaskan perbedaan dari "rebase –continue", "rebase –skip", dan "rebase –abort"!<br />
* **rebase-continue** adalah command yang digunakan untuk melakukan proses rebase setelah menyelesaikan konflik dari proses rebase yang sebelumnya.
* **rebase-skip** adalah command yang digunakan untuk melakukan ulang proses rebase dengan men-skip patch yang sedang dijalankan.
* **rebase-abort** adalah command yang digunakan untuk menggagalkan proses rebase dan meletakkan ulang HEAD ke cabang asli.

5. Jelaskan perbedaan git rebase dan git merge<br />
* **git-rebase** adalah command yang digunakan untuk menyatukan 2 branch dengan hanya mengambil pesan commit dari branch yang lain tanpa harus membuat pesan commit yang baru.
* **git-merge** adalah command yang digunakan untuk menyatukan 2 pesan commit atau lebih menjadi sebuah pesan commit yang baru.
Perbedaan antara kedua command tersebut adalah **git-rebase** akan membuat log commit yang ada lebih mudah dibaca namun akan lebih sulit untuk membenarkan code yang ada ketika terjadi konflik saat menggabungkan antara 2 branch. **git-merge** adalah kebalikannya dari hal tersebut.

6. Pada tahap ini apakah yang terjadi pada direktori git-stash?<br />
Yang terjadi pada direktori git-stash adalah kita akan menghilangkan code yang telah dibuat sebelumnya. Istilahnya, direktori git-stash akan kita *"cut"* dan nantinya akan kita *"paste"* ke dalam branch yang lain.

7. Apa yang terjadi pada file abc.txt setelah melakukan git reset --hard? Bagaimana kondisi lognya? Apa perbedaan git reset dengan git revert?<br />
Yang akan terjadi pada file abc.txt setelah melakukan git reset --hard adalah string **"this is second line from abc file"** akan menghilang. Kondisi dari lognya adalah pesan commit untuk **"update abc file 2"** akan menghilang.
* **git-reset** adalah command yang digunakan untuk
* **git-revert** adalah command yang digunakan untuk

## Tutorial 5
### Pertanyaan
1. Apa itu Postman? Apa kegunaannya?<br />
**Postman** merupakan aplikasi yang akan digunakan sebagai REST CLIENT untuk uji coba dari REST API. Kegunaan dari Postman adalah:<br />
* Menguji API yang sudah dibuat oleh para *developer*.
* Menyediakan fitur **Sharing Collectionn API**, **Testing API**, **Monitoring API**, dan lainnya.

2. Jelaskan fungsi dari anotasi @JsonIgnoreProperties dan @JsonProperty.<br />
* **@JsonIgnoreProperties** berfungsi untuk tidak memperhatikan *property* yang ditentukan dalam serialisasi dan deserialisasi JSON, terutama properti logis.
* **@JsonProperty** berfungsi sebagai sebuah *method* pengambil objek *non-static*

3. Apa kegunaan atribut WebClient?<br />
**WebClient** digunakan untuk restserviceimpl yang nantinya akan digunakan ketika mengirim dan menerima data dari URI.

4. Apa itu ResponseEntity dan BindingResult? Apa kegunaannya?<br />
* **ResponseEntity** merupakan perwakilan dari HTTP response. **ResponseEntity** memperbolehkan kita menambahkan sebuah header dan juga kode status.
* **BindingResult** berfungsi untuk menyimpan hasil validasi, pengikatan, dan berisi kesalahan yang mungkin terjadi. **BindingResult** harus ada tepat setelah objek model divalidasi.

## Tutorial 4
### Pertanyaan
1. Jelaskan perbedaan th:include dan th:replace!<br />
* **th:include**  memungkinkan kita untuk memasukkan code yang kita fragment ke dalam tag div agar nantinya konten yang ada dalam fragment juga ditampilkan.
* **th:replace** akan digunakan untuk mengubah host tag dengan isi konten yang ada pada fragment.

2. Jelaskan apa fungsi dari th:object! <br />
**th:object** berfungsi untuk menspesifikasikan suatu objek yang akan kita *submit* pada suatu *form*. Biasanya akan digunakan ketika menggunakan method POST dan setelah itu diiringi dengan **th:action**.

3. Jelaskan perbedaan dari * dan $ pada saat penggunaan th:object! Kapan harus dipakai?<br />
* *{} merupakan sebuah ekspresi dari sebuah variabel yang akan dipakai ketika ingin mengevaluasi suatu objek yang sudah didefinisikan pada controller.
* ${} merupakan sebuah ekspresi dari sebuah variabel yang akan dipakai ketika ingin mengevaluasi secara utuh suatu objek atau atribut.

## Tutorial 3
### What I have learned today
* Saya baru mengetahui bahwa mengetik isi dari class akan lebih cepat dari mengetik import terlebih dahulu
### Pertanyaan
1. Tolong jelaskan secara singkat apa kegunaan dari anotasi-anotasi yang ada pada model (@AllArgsConstructor, @NoArgsConstructor, @Setter, @Getter, @Entity, @Table) <br />
* **@AllArgsConstructor** berfungsi untuk membuat *constructor* yang nantinya akan membutuhkan argumen pada *class*.
* **@NoArgsConstructor** berfungsi untuk men-*generate constructor* kosong.
* **@Setter** berfungsi untuk men-*generate* fungsi *setter*.
* **@Getter** berfungsi untuk men-*generate* fungsi *getter*.
* **@Entity** berfungsi untuk mendefinisikan kelas yang ada berkorelasi dengan tabel pada *database*.
* **@Table** berfungsi untuk mendefinisikan nama tabel *database* yang akan digunakan.

2. Pada class CourseDb, terdapat method findByCodeUsingQuery dan findByCode, apakah perbedaan kedua method tersebut? Jelaskan juga kegunaan @Query pada method findByCodeUsingQuery! <br />
* Method **findByCodeUsingQuery** berfungsi untuk mencari Objek Course yang sesuai dengan codenya menggunakan Query.
* Method **findByCode** berfungsi untuk mencari Objek Course yang sesuai dengan codenya menggunakan method bawaan dari JPA Repository.
<br /><br />
**@Query** digunakan agar kita bisa menjalankan query sql untuk mencari code yang sesuai dari Course yang ingin kita lihat pada tabel relasi yang sudah kita buat. Atau dalam kata lain method tersebut digunakan untuk meng-*execute* JPQL dan *query native* dari SQL nya.

3. Jelaskan perbedaan kegunaan dari anotasi @JoinTable dan @JoinColumn <br />
* **@JoinColumn** berfungsi untuk membuat sebuah kolom baru pada *database* yang ada dan kolom tersebut digunakan untuk merefer kolom lain menggunakan *foreign key*.
* **@JoinTable** berfungsi untuk membuat pemetaan asosiasi-asosiasi seperti **many-to-many**, **many-to-one**, dan lainnya kedalam tabel *database*.

4. Pada class Pengajar, digunakan anotasi @JoinColumn pada atribut Course, apa kegunaan dari name, referencedColumnName, dan nullable dalam anotasi tersebut? dan apa perbedaan nullable dan penggunaan anotasi @NotNull <br />
* **referencedColumName** adalah sebuah kolom yang akan dirujuk dari kolom lain yang merupakan *doreign key*.
* **name** adalah nama kolom suatu *entity*.
* **nullable** digunakan untuk mencegah adanya data yang bersifat null pada *database*.
* Perbedaan antara **nullable** dan anotasi **@NotNull** adalah **nullable** menunjukkan status dari null tersebut, sementara **@NotNull** digunakan untuk mencegah adanya data yang null untuk masuk kedalam *database*.

5. Jelaskan kegunaan FetchType.LAZY, CascadeType.ALL, dan FetchType.EAGER <br />
* **FetchType.Lazy** digunakan untuk mengakses sebuah atribut yang saat dibutuhkan.
* **CascadeType.ALL** digunakan untuk mengambil atribut yang berelasi ketika *parent entity* diambil.
* **FetchType.EAGER** digunakan untuk menyebarkan operasi seperti **PERSIST**, **REMOVE**, **REFRESH**, **MERGE**, dan lainnya ke entitas yang terkait.

## Tutorial 2
### What I have learned today
* Saya berhasil mencoba dan memahami materi Organizing Domain Logic & Service Layer
### Pertanyaan
1. Cobalah untuk menambahkan sebuah Course dengan mengakses link berikut:
[Sebuah Link](http://localhost:8080/course/add?code=APAP&nameCourse=APAP%20Tutorial2&description=2020%20Fasilkom&jumlahSks=3)
Apa yang terjadi? Jelaskan mengapa hal tersebut dapat terjadi! <br />
Akan terjadi **Whitelabel Error**. *Error* ini akan terjadi karena file *controller* akan mencoba mengakses file html yang tidak tersedia, yaitu ketika file *controller* mengembalikan *string* nama file html yang dimana file html tersebut belum tersedia pada folder *template*.

2. Menurut kamu anotasi @Autowired pada class Controller tersebut merupakan implementasi dari konsep apa? Dan jelaskan secara singkat cara kerja @Autowired tersebut dalam konteks service dan controller yang telah kamu buat <br />
Anotasi **@Autowired** pada file *controller* adalah contoh implementasi dari *Dependency Injection*, yaitu sebuah fitur yang membuat Spring bisa menyelesaikan dan menyuntikkan *beans* yang berkolaborasi dengan *beans* lainnya.
*Reference*: 
> [Dependency Injection](https://www.baeldung.com/spring-autowire)   

3. Cobalah untuk menambahkan sebuah Course dengan mengakses link berikut: <br />
[Sebuah Link](http://localhost:8080/course/add?code=APAP&nameCourse=APAP%20Tutorial2&jumlahSks=3)   
Apa yang terjadi? Jelaskan mengapa hal tersebut dapat terjadi! <br />
Akan terjadi **Whitelabel Error**. *Error* ini akan terjadi karena method *addCourse* membutuhkan sebuah parameter description untuk menambahkan sebuah course ke dalam *listCourse*, sementara parameter yang dibutuhkan tidak ada.

4. Jika Papa APAP ingin melihat Course dengan kode APAP, link apa yang harus diakses? <br />
Link yang dapat diakses oleh Papa APAP adalah sebagai berikut:
* [Link 1](http://localhost:8080/course/view?code=APAP) yang akan menggunakan *RequestParam*.
* [Link 2](http://localhost:8080/course/view/code-course/APAP) yang akan menggunakan *PathVariable*.
Papap APAP bisa mengakses link tersebut karena kedua link itu akan mengarahkan user untuk mampu melihat detail course apapun dengan kode spesifik yang harus dimasukkan.

5. Tambahkan 1 contoh Course lainnya sesukamu. Lalu cobalah untuk mengakses > [Sebuah Link](http://localhost:8080/course/viewAll), apa yang akan ditampilkan? Sertakan juga bukti screenshotmu. <br />
Yang akan ditampilkan adalah detail seluruh course yang akan menampilkan:
* **Code**
* **Nama Course**
* **Description**
* **Jumlah Sks** <br />
Untuk contoh course yang akan saya tambahkan adalah (bukti penambahan bisa diakses melalui link ini [Link Bukti](https://drive.google.com/drive/folders/1tb_SLx-8CEpsnoSTjrp1CxaT7i4lYolL?usp=sharing)): <br />
* Kode = **SOSI**
* Nama Course = **APAP Tutorial2**
* Description = **2020 Fasilkom**
* Jumlah Sks = **3**

## Tutorial 1
### What I have learned today
* Saya berhasil mencoba *hands on* membuat program BMI sederhana menggunakan Spring Boot
* Saya berhasil mengingat dan mengoperasikan kembali *command-command* pada penggunaan GitLab
### GitLab
1. Apa itu Issue Tracker? Apa saja masalah yang dapat diselesaikan dengan Issue Tracker? <br />
**Issue Tracker**, merupakan fitur yang ada pada GitHub yang berfungsi untuk memudahkan *user* untuk tetap *on track* dan mengerahui perubahan apa saja yang terjadi pada proyek. Selain itu, **Issue Tracker** juga bisa membantu *user* untuk menemukan bug yang ada pada proyek.
*Reference*:
> [About issues](https://docs.github.com/en/issues/tracking-your-work-with-issues/about-issues)

2. Apa perbedaan dari git merge dan git merge --squash? <br />
*command* `git merge --squash` akan menyatukan semua commit pada suatu branch menjadi 1 commit saja. Sehingga, jika *user* ingin melakukan merge ke branch main, maka branch tersebut hanya memberikan 1 commit.
*Reference*:
> [git merge VS git merge -- squash](https://monsterlessons-academy.com/p/git-squash-how-to-combine-git-commits-with-merge-and-rebase)

3. Apa keunggulan menggunakan Version Control System seperti Git dalam pengembangan suatu aplikasi? <br />
Fungsi dari **Version Control System** adalah menyimpan perubahan pada *source code*, sehingga mampu meminimalisir resiko gagal ada kode yang sudah kita ubah.
*Reference*:
> [Version Control System](https://glints.com/id/lowongan/version-control-system/#.YTjZGp0zaUk)
### Spring
4. Apa itu library & dependency? <br />
* **Library** merupakan kumpulan code pada sebuah modul yang bisa dipakai oleh *user* untuk memudahkan pembuatan suatu proyek.
* **Dependency** merupakan sebuah kata yang mereferensikan ketika suatu *software* saling berkaitan dengan *software* lainnya.
*Reference*:
> [Library](https://id.quora.com/Apa-yang-dimaksud-dengan-library-pada-pemrograman)
> [Dependency](https://coderslegacy.com/what-are-dependencies-in-programming/)

5. Apa itu Gradle? Mengapa kita menggunakan Gradle? Apakah ada alternatif dari Gradle? <br />
**Gradle** merupakan *automation tool* untuk membangun *software*. **Gradle** kita gunakan karena **Gradle** mampu memberikan performa yang sangat baik dan juga **Gradle** saat ini sudah bisa dipakai oleh *user* di berbagai macam IDE yang ada di pasar saat ini. Alternatif lain dari penggunaan **Gradle** adalah Maven, Bazel, dan lainnya.
*Reference*:
> [About Gradle](https://www.simplilearn.com/tutorials/gradle-tutorial/what-is-gradle)
> [Gradle altenatives](https://rigorousthemes.com/blog/best-gradle-alternatives/)

6. Selain untuk pengembangan web, apa saja yang bisa dikembangkan dengan Spring framework? <br />
**Spring framewor** dapat digunakan untuk Cloud, Reactive, Event Driven, dan sebagainya.
*Reference*:
> [Spring framework](https://spring.io/projects/spring-framework)

7. Apa perbedaan dari @RequestParam dan @PathVariable? Kapan sebaiknya menggunakan @RequestParam atau @PathVariable? <br />
* **@RequestParam** digunakan untuk mengakses nilai dari parameter.
* **@PathVariable** digunakan untuk mengakses nilai dari template URI.
*Reference*:
> [RequestParam VS PathVariable](https://javabeat.net/spring-mvc-requestparam-pathvariable/)
### What I did not understand
Saya masih belum terbiasa dengan sistem branch pada gitlab, karena selama ini saya hanya menggunakan branch main pada gitlab. Saya juga baru pertama kali menggunakan spring boot, sehingga saya masih tidak mengerti apa yang saya ketikkan pada kode yang ada pada Tutorial 1 ini.
- [x] Apakah saya mampu lulus APAP dengan nilai memuaskan?
**YA**. Karena saya mampu dan saya ingin.
