package apap.tutorial.belajarbelajar.controller;

import java.security.Principal;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;

import apap.tutorial.belajarbelajar.model.RoleModel;
import apap.tutorial.belajarbelajar.model.UserModel;
import apap.tutorial.belajarbelajar.service.RoleService;
import apap.tutorial.belajarbelajar.service.UserService;

@Controller
@RequestMapping("/user")
public class UserController {
  @Autowired
  private UserService userService;

  @Autowired
  private RoleService roleService;

  @GetMapping(value = "/add")
  private String addUserFormPage(Model model) {
    UserModel user = new UserModel();
    List<RoleModel> listRole = roleService.findAll();
    model.addAttribute("user", user);
    model.addAttribute("listRole", listRole);
    return "form-add-user";
  }

  @PostMapping(value = "/add")
  private String addUserSubmit(@ModelAttribute UserModel user, Model model) {
    user.setIsSso(false);
    userService.addUser(user);
    model.addAttribute("user", user);
    return "redirect:/";
  }

  @GetMapping(value = "/viewall")
  public String listUser(Model model) {
    List<UserModel> listUser = userService.getListUser();
    model.addAttribute("listUser", listUser);
    return "viewall-user";
  }

  @GetMapping(value = "/update")
  public String updatePasswordFormPage(Model model, Principal principal) {
    String username = principal.getName();
    UserModel user = userService.getUserByUsername(username);
    model.addAttribute("user", user);

    return "form-update-password";
  }

  @PostMapping(value = "/update")
  public String updatePasswordSubmitPage(@ModelAttribute UserModel user, String newPassword, String confirmNewPassword, Model model) {
    UserModel currentUser = userService.getUserByUsername(user.getUsername());
    if (userService.isTheSamePassword(user.getPassword(), currentUser.getPassword())) {
      if (newPassword.equals(confirmNewPassword)) {
        userService.setPassword(currentUser, newPassword);
        userService.addUser(currentUser);
      }
    }

    // UserModel updatedUser = userService.updatePassword(user);
    model.addAttribute("username", user.getUsername());
    return "update-password";
  }
}

// @PostMapping("/updatePassword")
//     private String updatePasswordFormSubmit(
//             @ModelAttribute UserModel user,
//             String newPassword,
//             String confirmPass,
//             Model model
//     ) {
//         UserModel myUser = userService.getUserByUsername(user.getUsername());
//         String msg = "";
//         String status = "";
//         if (userService.passwordEqual(user.getPassword(), myUser.getPassword())){
//             if (newPassword.equals(confirmPass)){
//                 userService.setPassword(myUser, newPassword);
//                 userService.addUser(myUser);
//                 msg += "Password berhasil di-update";
//                 status += "success";
//             }
//             else {
//                 msg += "Konfirmasi password yang diberikan tidak sesuai!";
//                 status += "failed";
//             }
//         }
//         else {
//             msg += "Password yang anda masukan salah";
//             status += "failed";
//         }
//         model.addAttribute("msg", msg);
//         model.addAttribute("status", status);
//         model.addAttribute("username", user.getUsername());
//         return "update-password";
//     }