package apap.tutorial.belajarbelajar.service;

import java.util.List;

import javax.transaction.Transactional;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.stereotype.Service;

import apap.tutorial.belajarbelajar.model.UserModel;
import apap.tutorial.belajarbelajar.repository.UserDb;

@Service
@Transactional
public class UserServiceImpl implements UserService {
  @Autowired
  private UserDb userDb;

  @Override
  public UserModel addUser(UserModel user) {
    String pass = encrypt(user.getPassword());
    user.setPassword(pass);
    return userDb.save(user);
  }

  @Override
  public String encrypt(String password) {
    BCryptPasswordEncoder passwordEncoder = new BCryptPasswordEncoder();
    String hashedPassword = passwordEncoder.encode(password);
    return hashedPassword;
  }
  
  @Override
  public UserModel getUserByUsername(String username) {
    UserModel user = userDb.findByUsername(username);
    return user;
  }

  @Override
  public List<UserModel> getListUser(){
    return userDb.findAll();
  }

  @Override
  public UserModel updatePassword(UserModel user) {
    userDb.save(user);
    return user;
  }

  @Override
  public boolean isTheSamePassword(String oldPasswordDb, String oldPasswordForm) {
    BCryptPasswordEncoder passwordEncoder = new BCryptPasswordEncoder();
    return passwordEncoder.matches(oldPasswordDb, oldPasswordForm);
  }

  @Override
  public void setPassword(UserModel user, String newPassword) {
    user.setPassword(newPassword);
  }
}
